<template>
  <fieldset>
    <fieldset class="autocomplete">
      <TextInputFloatingLabel :text="t('Station name')" for="stationName">
        <input
            type="text"
            @input="autocompleteStations"
            name="stationName"
            id="stationName"
            class="autocomplete__input"
            :placeholder="t('search for a station')"
            v-model="currentSearch"
        >
      </TextInputFloatingLabel>
      <ul class="autocomplete__list" v-show="stationCandidates.length > 0">
        <li v-show="loadingAutocomplete">
          {{ t("Loading search results") }} …
        </li>
        <li
            v-for="candidate in stationCandidates"
            :key="candidate.id"
            @click="setStation(candidate)"
            class="autocomplete__list-item"
        >{{ candidate.name }}
        </li>
      </ul>
      <input
          type="hidden"
          name="stationId"
          id="stationId"
          :value="currentSettings.stationId"
      >
    </fieldset>
    <fieldset>
      <legend>{{ t("filter transport types") }}</legend>
      <div class="sbb-four-up">
        <template v-for="type in transitTypes">
          <CheckBoxBorderedLabel :key="type" :for="`chosenTransitTypes_${type}`" :text="t(type)|capitalize">
            <input
                type="checkbox"
                name="chosenTransitTypes"
                :id="`chosenTransitTypes_${type}`"
                :value="type"
                :checked="currentSettings.chosenTransitTypes.includes(type)"
            >
          </CheckBoxBorderedLabel>
        </template>
      </div>
    </fieldset>
  </fieldset>
</template>

<script>
module.exports = {
  name: "sbb",
  props: {
    currentSettings: {
      type: Object,
      required: false,
      default: function () {
        return {
          stationName: null,
          stationId: null,
          limit: 5,
          chosenTransitTypes: ["train", "tram", "ship", "bus", "cableway"]
        }
      }
    },
    locale: {
      type: String,
      required: false
    }
  },
  data: function () {
    return {
      stationCandidates: [],
      currentSearch: this.currentSettings.stationName,
      loadingAutocomplete: false,
      transitTypes: ["train", "tram", "ship", "bus", "cableway"]
    };
  },
  locales: {
    deDe: {
      "Loading search results": "Suchergebnisse laden",
      "Station name": "Name der Haltestelle",
      "filter transport types": "Nur diese Fahrzeug-Typen abfragen",
      train: "Zug",
      tram: "Trambahn",
      ship: "Schiff",
      bus: "Bus",
      cableway: "Seilbahn"
    }
  },
  methods: {
    autocompleteStations: async function (e) {
      this.stationCandidates = [];
      if (e.target.value.length <= 2) {
        return;
      }
      this.loadingAutocomplete = true;
      // FIXME: This relies on axios bein available through vue-axios in the main app.
      const res = await this.axios.get(
          `https://transport.opendata.ch/v1/locations?query=${
              e.target.value
          }&?type=station`
      );
      this.stationCandidates = res.data.stations;
      this.loadingAutocomplete = false;
    },
    setStation: function (station) {
      this.currentSettings.stationName = station.name;
      this.currentSettings.stationId = station.id;
      this.currentSearch = station.name;
      this.stationCandidates = [];
    }
    /* handleStepper: function(direction) {
      switch (direction) {
        case "increment":
          this.currentSettings.limit = Number.parseInt(this.currentSettings.limit) + 1;
          break;
        case "decrement":
          this.currentSettings.limit = Math.max(Number.parseInt(this.currentSettings.limit) - 1, 0);
          break;
        default:
          break;
      }
    } */
  }
};
</script>
<style scoped>
.autocomplete {
  width: 100%;
  position: relative;
  margin-bottom: 1rem;
}

.autocomplete__input {
  margin-bottom: 0;
}

.autocomplete__list {
  list-style-type: none;
  background-color: #fff;
  border: 3px solid #eeeeee;
  box-sizing: border-box;
  max-height: 200px;
  overflow-y: scroll;
  overflow-x: hidden;
  position: absolute;
  width: 100%;
  margin-left: 0;
  margin-block-start: 0;
  margin-block-end: 0;
  z-index: 1;
}

.autocomplete__list-item {
  padding: 0.25rem;
  border-bottom: 1px solid #eeeeee;
}

.autocomplete__list-item:hover {
  background-color: #8ba4c1;
}

.sbb-four-up {
  display: flex;
  flex-wrap: wrap;
  justify-content: space-between;
}

.sbb-four-up > label {
  flex-basis: 45%;
}
</style>
